<?php

//getting database connection
require_once 'includes/connection.php';
include("includes/function.php");
include("includes/data.php");
$settings = getById("tbl_books_settings", "1");

$imagepath = getBaseUrl();

  
$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443 || $_SERVER['HTTP_X_FORWARDED_PORT'] == 443) ? "https://" : "http://";
$file_path = $protocol.$_SERVER['SERVER_NAME'] . dirname($_SERVER['REQUEST_URI']).'/uploads/books/';

//array to show the response
$response = array();
$getByCat = $_GET['getByCat'];
$getByAuthor = $_GET['getByAuthor'];
$key_get = $_GET['key'];
$get_limit = $_GET['limit'];
$get_popular = $_GET['popular'];
$get_banner = $_GET['banner'];
$get_search = $_GET['search'];
$get_byid = $_GET['byid'];

$headers = apache_request_headers();
$get_pcode = $headers['Pcode'];
$get_pname = $headers['Pname'];

if (!isset($get_pcode) && !isset($get_pname)) {
$get_pcode = $headers['pcode'];
$get_pname = $headers['pname'];
}
if (!isset($_GET['do']) == "verify") {
    if (!isset($get_pcode) && !isset($get_pname)) {
        header("WWW-Authenticate: Basic realme=\"Private Area\"");
        header("HTTP/1.0 401 Unauthorized");
        $response['error'] = true;
        $response['message'] = 'Invalid Purchase Code or Package Name';
    } else if ($get_pcode == PURCHASE_CODE && $get_pname == PACKAGE_NAME) {
        if ($key_get == $settings['api_key']) {

            if (isset($_GET['getByCat'])) {
                $query = "SELECT id, aid, cid, title, description, image, posted_at, book_file_type, file_url, views, banner_status, c.category_name as category_name, a.author_name as author_name FROM tbl_books 
                LEFT JOIN tbl_books_category c ON cid = c.cat_id
                LEFT JOIN tbl_books_author a ON aid = a.a_id
                WHERE
                c.cat_id = $getByCat AND book_status = 1 ORDER BY id DESC";
                $stmt = $mysqli->prepare($query);
                $stmt->execute();
                $stmt->bind_result($id, $aid, $cid, $title, $description, $image, $posted_at, $book_file_type, $file_url, $views, $banner_status, $category_name, $author_name);

                while ($stmt->fetch()) {
                    $data = array();
                    $data['id'] = $id;
                    $data['aid'] = $aid;
                    $data['cid'] = $cid;
                    $data['title'] = $title;
                    $data['description'] = $description;
                    $data['image'] = $imagepath . 'images/' . $image;
                    $data['date'] = date("d-m-Y", $posted_at);
                    $data['book_file_type'] = $book_file_type;
                    $data['file_url'] = $file_path.$file_url;
                    $data['views'] = $views;
                    $data['banner_status'] = $banner_status;
                    $data['category_name'] = $category_name;
                    $data['author_name'] = $author_name;
                    array_push($response, $data);
                }
            }


            if (isset($_GET['apicall'])) {

                switch ($_GET['apicall']) {
                    
                    case 'settings':
                    $query = "SELECT ad_status, inter_clicks, ad_network, admob_small_banner, admob_medium_banner, admob_inter, admob_native, 
                    facebook_small_banner, facebook_medium_banner, facebook_inter, facebook_native,
                    applovin_small_banner, applovin_medium_banner, applovin_inter, applovin_native, startapp_app_id, onesignal_app_id, about_us_email, about_us_contact, about_us_website, about_us_developer, about_us_description FROM tbl_books_settings LEFT JOIN tbl_ads_settings ad ON id = ad.ad_id";

                    $stmt = $mysqli->prepare($query);
                    $stmt->execute();
                    $stmt->bind_result($ad_status, $inter_clicks, $ad_network, $admob_small_banner, $admob_medium_banner, $admob_inter, $admob_native, 
                    $facebook_small_banner, $facebook_medium_banner, $facebook_inter, $facebook_native,
                    $applovin_small_banner, $applovin_medium_banner, $applovin_inter, $applovin_native, $startapp_app_id, $onesignal_app_id, 
                    $about_us_email, $about_us_contact, $about_us_website, $about_us_developer, $about_us_description);

                    while ($stmt->fetch()) {
                        $data = array();
                        $data['ad_status'] = $ad_status;
                        $data['inter_clicks'] = $inter_clicks;
                        $data['ad_network'] = $ad_network;
                        $data['admob_small_banner'] = $admob_small_banner;
                        $data['admob_medium_banner'] = $admob_medium_banner;
                        $data['admob_inter'] = $admob_inter;
                        $data['admob_native'] = $admob_native;
                        $data['facebook_small_banner'] = $facebook_small_banner;
                        $data['facebook_medium_banner'] = $facebook_medium_banner;
                        $data['facebook_inter'] = $facebook_inter;
                        $data['facebook_native'] = $facebook_native;
                        $data['applovin_small_banner'] = $applovin_small_banner;
                        $data['applovin_medium_banner'] = $applovin_medium_banner;
                        $data['applovin_inter'] = $applovin_inter;
                        $data['applovin_native'] = $applovin_native;
                        $data['startapp_app_id'] = $startapp_app_id;
                        $data['onesignal_app_id'] = $onesignal_app_id;
                        $data['about_us_email'] = $about_us_email;
                        $data['about_us_contact'] = $about_us_contact;
                        $data['about_us_website'] = $about_us_website;
                        $data['about_us_developer'] = $about_us_developer;
                        $data['about_us_description'] = $about_us_description;
                        array_push($response, $data);
                    }

                    break;

                    case 'category':
                        
                        $query = "SELECT
                        cat_id, category_name, category_image FROM tbl_books_category WHERE status = 1 ORDER BY cat_id DESC";
                        
                        $stmt = $mysqli->prepare($query);
                        $stmt->execute();
                        $stmt->bind_result($cat_id, $category_name, $category_image);

                        while ($stmt->fetch()) {
                            $data = array();
                            $data['cat_id'] = $cat_id;
                            $data['category_name'] = $category_name;
                            $data['category_image'] = $imagepath . 'images/' . $category_image;
                            array_push($response, $data);
                        }

                        break;

                    case 'author':
                        $query = "SELECT
                        a_id, author_name, author_image FROM tbl_books_author WHERE status = 1 ORDER BY a_id DESC";
                        
                        $stmt = $mysqli->prepare($query);
                        $stmt->execute();
                        $stmt->bind_result($a_id, $author_name, $author_image);

                        while ($stmt->fetch()) {
                            $data = array();
                            $data['a_id'] = $a_id;
                            $data['author_name'] = $author_name;
                            $data['author_image'] = $imagepath . 'images/' . $author_image;
                            array_push($response, $data);
                        }

                        break;

                    case 'books':
                        if (isset($_GET['search'])) {
                            $SearchField = '%' . $get_search . '%';
                            $query = "SELECT id, aid, cid, title, description, image, posted_at, book_file_type, file_url, views, banner_status, a.author_name as author_name FROM tbl_books LEFT JOIN tbl_books_author a ON aid = a.a_id WHERE title LIKE '" . $SearchField . "' AND book_status = 1 ";
                        } else if (isset($_GET['byid'])) {
                            $query = "SELECT id, aid, cid, title, description, image, posted_at, book_file_type, file_url, views, banner_status, a.author_name as author_name FROM tbl_books LEFT JOIN tbl_books_author a ON aid = a.a_id WHERE FIND_IN_SET(`id`, '$get_byid') AND book_status = 1";
                        } else if (isset($_GET['getByAuthor'])) {
                            $query = "SELECT id, cid, aid, title, description, image, posted_at, book_file_type, file_url, views, banner_status, a.author_name as author_name FROM tbl_books 
            LEFT JOIN tbl_books_author a ON aid = a.a_id WHERE
                a.a_id = '" . $getByAuthor . "' AND book_status = 1 ORDER BY id DESC";
                        } else {
                            $query = "SELECT id, aid, cid, title, description, image, posted_at, book_file_type, file_url, views, banner_status, a.author_name as author_name FROM tbl_books LEFT JOIN tbl_books_author a ON aid = a.a_id WHERE book_status = 1 ORDER BY id DESC";
                        }
                        $stmt = $mysqli->prepare($query);
                        $stmt->execute();
                        $stmt->bind_result($id, $aid, $cid, $title, $description, $image, $posted_at, $book_file_type, $file_url, $views, $banner_status, $author_name);

                        while ($stmt->fetch()) {
                            $data = array();
                            $data['id'] = $id;
                            $data['aid'] = $aid;
                            $data['cid'] = $cid;
                            $data['title'] = $title;
                            $data['description'] = $description;
                            $data['image'] = $imagepath . 'images/' . $image;
                            $data['date'] = date("d-m-Y", $posted_at);
                            $data['book_file_type'] = $book_file_type;
                            $data['file_url'] = $file_path.$file_url;
                            $data['views'] = $views;
                            $data['banner_status'] = $banner_status;
                            $data['author_name'] = $author_name;
                            array_push($response, $data);
                        }

                        break;

                    case 'update':
                        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                        
                            $id = $_POST['id'];
                            $views = $_POST['views'];

                            $Sql_Query = "UPDATE tbl_books SET views= '$views' WHERE id = $id";

                            if (mysqli_query($mysqli, $Sql_Query)) {
                                echo 'Record Updated Successfully';
                            } else {
                                echo 'Something went wrong';
                            }
                        }
                        mysqli_close($mysqli);
                        break;
                        
                    case 'home':
                    //fetch slider
                    $qry_slider = "SELECT * FROM tbl_books LEFT OUTER JOIN tbl_books_author a ON aid = a.a_id WHERE book_status = 1 AND banner_status = 1 ORDER BY id DESC LIMIT ".$settings_details['books_slider_limit']." ";
                    $result_slider = $mysqli->query($qry_slider);
                    $slider_array = array();
                    if($result_slider){
                    while ($slider_rows = mysqli_fetch_assoc($result_slider)) {
                    $data1 = array(); 
                    $data1['id'] = $slider_rows['id'];
                    $data1['title'] = $slider_rows['title'];
                    $data1['author_name'] = $slider_rows['author_name'];
                    $data1['date'] = date("d-m-Y", $slider_rows['posted_at']);
                    $data1['views'] = $slider_rows['views'];
                    $data1['description'] = $slider_rows['description'];
                    $data1['image'] = $imagepath . 'images/'. $slider_rows['image']; 
                    $data1['file_url'] = $file_path.$slider_rows['file_url'];
                    array_push($slider_array, $data1);
                    }
                    } else {
                    $data1['error'] = true;
                    $data1['message'] = 'Something Went Wrong!';
                    array_push($slider_array, $data1);
                    }
                    
                    //fetch latest stories
                    $popular_books_array = array();
                    $qry_popular_books = "SELECT * FROM tbl_books  LEFT OUTER JOIN tbl_books_author a ON aid = a.a_id WHERE book_status = 1 ORDER BY views DESC LIMIT ".$settings_details['popular_books_limit']." ";
                    $popular_books_result = $mysqli->query($qry_popular_books);
                    if($popular_books_result){
                    while ($popular_books_rows = mysqli_fetch_assoc($popular_books_result)) {
                    $data2 = array(); 
                    $data2['id'] = $popular_books_rows['id'];
                    $data2['title'] = $popular_books_rows['title'];
                    $data2['author_name'] = $popular_books_rows['author_name'];
                    $data2['date'] = date("d-m-Y", $popular_books_rows['posted_at']);
                    $data2['views'] = $popular_books_rows['views'];
                    $data2['description'] = $popular_books_rows['description'];
                    $data2['image'] = $imagepath . 'images/'. $popular_books_rows['image']; 
                    $data2['file_url'] = $file_path.$popular_books_rows['file_url'];
                    array_push($popular_books_array, $data2);
                    }
                    }
                    else {
                    $data2['error'] = true;
                    $data2['message'] = 'Something Went Wrong!';
                    array_push($popular_books_array, $data2);
                    }
                    
                    //fetch cat
                    $qry_cat = "SELECT * FROM tbl_books_category WHERE status = 1 ORDER BY cat_id DESC LIMIT ".$settings_details['latest_category_limit']." ";
                    $cat_result = $mysqli->query($qry_cat);
                    $cat_array = array(); 
                    if($cat_result){
                    while ($cat_rows = mysqli_fetch_assoc($cat_result)) {
                    $data3 = array(); 
                    $data3['cat_id'] = $cat_rows['cat_id'];
                    $data3['category_name'] = $cat_rows['category_name'];
                    $data3['category_image'] = $imagepath . 'images/'. $cat_rows['category_image'];
                    array_push($cat_array, $data3);
                    }
                    } else {
                        
                    $data3['error'] = true;
                    $data3['message'] = 'Something Went Wrong!';
                    array_push($cat_array, $data3);
                    }
                    
                    //fetch authors
                    $qry_author = "SELECT * FROM tbl_books_author WHERE status = 1 ORDER BY a_id DESC LIMIT ".$settings_details['latest_author_limit']." ";
                    $author_result = $mysqli->query($qry_author);
                    $author_array = array(); 
                    if($author_result){
                    while ($author_rows = mysqli_fetch_assoc($author_result)) {
                    $data4 = array(); 
                    $data4['a_id'] = $author_rows['a_id'];
                    $data4['author_name'] = $author_rows['author_name'];
                    $data4['author_image'] = $imagepath . 'images/'. $author_rows['author_image'];
                    array_push($author_array, $data4);
                    }
                    } else {
                        
                    $data4['error'] = true;
                    $data4['message'] = 'Something Went Wrong!';
                    array_push($author_array, $data4);
                    }
                    
                    $data_final['books_slider'] = $slider_array;
                    $data_final['popular_books'] = $popular_books_array;
                    $data_final['categories'] = $cat_array;
                    $data_final['authors'] = $author_array;
                    
                    array_push($response, $data_final);

                break;

                    default:
                        $response['error'] = true;
                        $response['message'] = 'Invalid Operation Called';
                }
            }
        } else {
            $response['error'] = true;
            $response['message'] = 'Invalid Api Key';
        }
    } else {
        $response['error'] = true;
        $response['message'] = 'Invalid Purchase Code or Package Name';
    }
}

if (isset($_GET['do']) == "verify") {
    $code = $_GET['pcode'];
    $code = trim($code);
    verify_envato_purchase_code($code);
}



header('Content-Type: application/json; charset=utf-8');
echo $response = str_replace('\\/', '/', json_encode($response, JSON_UNESCAPED_UNICODE | JSON_PRETTY_PRINT));

?>
